setClass("pcaRes",
         representation(scores="matrix",
                        loadings="matrix",
                        R2cum="numeric",
                        R2="numeric",
                        sdev="numeric",
                        nobs="numeric",
                        nvar="numeric",
                        centered="logical",
                        center="numeric",
                        subset="numeric",
                        varLimit="numeric",
                        scaled="character",
                        k="numeric",
                        method="character",
                        missing="numeric"),
         prototype(scores=NULL,
                   loadings=NULL,
                   R2cum=NULL,
                   R2=NULL,
                   sdev=NULL,
                   nobs=NULL,
                   nvar=NULL,
                   centered=NULL,
                   center=NULL,
                   subset=NULL,
                   varLimit=NULL,
                   scaled=NULL,
                   k=NULL,
                   method=NULL,
                   missing=NULL))
                   
                   
setAs("NULL", "pcaRes",
      function(from, to){
        new(to)
      })
###**********************************************************
setClass("batchPcaRes",
         representation(pcaModels="list"),
         prototype(pcaModels=NULL))

setAs("NULL", "batchPcaRes",
      function(from, to) {
        new(to)
      })

###**********************************************************
setClass("modelScores",
         representation(scores="numeric",
                        clusterings="matrix",
                        sizes="numeric",
                        certainty="matrix",
                        scoretype="character"),
         prototype(scores=NULL,
                   clusterings=NULL,
                   sizes=NULL,
                   certainty=NULL,
                   scoretype=NULL))

setAs("NULL", "modelScores",
      function(from, to) {
        new(to)
      })
###**********************************************************
setClass("node",
         representation(ranks="numeric",
                        classes="character",
                        clustering="numeric",
                        children="numeric",
                        scores="numeric",
                        sizes="numeric",
                        members="list",
                        type="character"),
         prototype(ranks=NULL,
                   classes=NULL,
                   clustering=NULL,
                   children=NULL,
                   scores=NULL,
                   sizes=NULL,
                   members=NULL,
                   type=NULL))
setAs("NULL", "node",
      function(from, to) {
        new(to)
      })
###**********************************************************
setClass("udt",
         representation(nodes="list",
                       labels="character"),
         prototype(nodes=NULL,
                   labels=NULL))
setAs("NULL", "udt",
      function(from, to) {
        new(to)
      })
