progBar <- function(i, to, start=1, dots=50) {
  ## A simple progress bar usable in any loop structure with a counter
  ## i...the current round
  ## to...last round
  ## start...first round
  ## dots...desired approximate length of progress bar
  if(dots > to)
    dots <- to
  step <- ifelse(as.integer(to / dots) == 0, 1, as.integer(to / dots))
  if(i == start) {
    cat("Wait for", ceiling(to / step), "dots\n")
    cat(rep(".", ceiling(to / step)), "\n", sep="")
  }
  if((i %% step) == 0)
    cat(".")
  if(i == to)
    cat("\n")
}


